//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uEditOption.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "uEditBase"
#pragma resource "*.dfm"
TEditOption *EditOption;
//---------------------------------------------------------------------------
__fastcall TEditOption::TEditOption(TComponent* Owner)
        : TEditBase(Owner)
{
}
//---------------------------------------------------------------------------
Variant TEditOption::GetValue() {
  if (rbOption->Checked) {
    return FCheckedValue;
  } else {
    return Null;
  }
}

void TEditOption::SetValue(Variant NewValue) {
  rbOption->Checked = (NewValue == FCheckedValue);
  CheckDefaultValue();
}

void TEditOption::LoadValue() {
  AnsiString v;
  int length = ((AnsiString)FCheckedValue).Length();
  for (int i = 0; i < length; i++) {
    v += (char) *(byte*)FSMC->ROM_pointer(FOffset + i);
  }
  Value = v;
}

void TEditOption::SaveValue() {
  Variant va = Value;
  if (VarIsNull(va)) return;
  AnsiString v = va;
  for (int i = 0; i < v.Length(); i++) {
    *(byte*)FSMC->ROM_pointer(FOffset + i) = v[i+1];
  }
}

void __fastcall TEditOption::rbOptionClick(TObject *Sender)
{
  TWinControl* p = this->Parent;
  int n = p->ControlCount;
  for (int i = 0; i < n; i++) {
    // uncheck others in the same group
    if (TEditOption* opt = dynamic_cast<TEditOption*>(p->Controls[i])) {
      if (opt != this) {
        opt->rbOption->Checked = false;
        opt->CheckDefaultValue();
      }
    }
  }
  CheckDefaultValue();
}
//---------------------------------------------------------------------------
